<template>
  <div>
    <el-dialog :close-on-click-modal="false" :title="'新增排查' + title + '明细'" :visible.sync="showTroubleshooting"
      width="60%" :before-close="handleClose" top="8vh" append-to-body>
      <template>
        <el-tabs v-model="activeName" type="card" @tab-click="handleClick">
          <el-tab-pane label="九小场所管理" name="九小场所管理">
            <div class="bbsl-table-search">
              <el-form v-model="queryParam" :inline="true">
                <!-- <el-form-item label="所属片区">
                  <el-select v-model="querys[1].value" style="width:100%" clearable placeholder="请选择所属片区">
                    <el-option v-for="item in jxcspqList" :key="item.value" :label="item.name" :value="item.value" />
                  </el-select>
                </el-form-item> -->
                <el-form-item label="商户名称">
                  <el-input v-model="querys[0].value" clearable placeholder="请输入商户名称" />
                </el-form-item>
                <el-form-item>
                  <el-button type="primary" icon="el-icon-search" @click="handleSearch">搜索</el-button>
                  <el-button icon="el-icon-refresh" @click="handleReset">重置</el-button>
                </el-form-item>
              </el-form>
            </div>
            <el-table ref="multipleSelection" v-loading="loading" border size="mini" :data="tableData" height="52vh"
              :style="{ width: '100%', height: '500px' }" :max-height="tableMaxHeight"
              :cell-style="{ 'text-align': 'center' }" :header-cell-style="{ 'text-align': 'center' }"
              @row-dblclick="handleDbClick" @selection-change="handleSelectionChange" @select="checkSelect"
              @select-all="checkSelect" v-if="activeName === '九小场所管理'" :row-key="getRowKey">
              <el-table-column type="selection" width="55" :reserve-selection="true" />
              <el-table-column type="index" width="55" label="序号" />
              <!-- <el-table-column prop="smallPlaceAreaName" min-width="150" label="所属片区" show-overflow-tooltip /> -->
              <el-table-column prop="unitName" label="商户名称" show-overflow-tooltip />
              <el-table-column prop="name" label="负责人" show-overflow-tooltip />
              <el-table-column prop="phone" label="联系电话" show-overflow-tooltip />
            </el-table>
          </el-tab-pane>
          <el-tab-pane label="重点单位管理" name="重点单位管理">
            <div class="bbsl-table-search">
              <el-form v-model="queryParam" :inline="true">
                <el-form-item label="单位名称">
                  <el-input v-model="querys[0].value" clearable placeholder="请输入单位名称" />
                </el-form-item>
                <el-form-item>
                  <el-button type="primary" icon="el-icon-search" @click="handleSearch">搜索</el-button>
                  <el-button icon="el-icon-refresh" @click="handleReset">重置</el-button>
                </el-form-item>
              </el-form>
            </div>
            <el-table ref="multipleSelection" v-loading="loading" border size="mini" :data="tableData"
              :style="{ width: '100%', height: '500px' }" height="52vh" :max-height="tableMaxHeight"
              :cell-style="{ 'text-align': 'center' }" :header-cell-style="{ 'text-align': 'center' }"
              @row-dblclick="handleDbClick" @selection-change="handleSelectionChange" @select="checkSelect"
              @select-all="checkSelect" v-if="activeName === '重点单位管理'" :row-key="getRowKey">
              <el-table-column type="selection" width="55" :reserve-selection="true" />
              <el-table-column type="index" width="55" label="序号" />
              <el-table-column prop="unitName" label="单位名称" show-overflow-tooltip />
              <el-table-column prop="name" label="负责人" show-overflow-tooltip />
              <el-table-column prop="phone" label="联系电话" show-overflow-tooltip />
            </el-table>
          </el-tab-pane>
          <el-tab-pane label="其它经营场所" name="其它经营场所">
            <div class="bbsl-table-search">
              <el-form v-model="queryParam" :inline="true">
                <!-- <el-form-item label="所属片区">
                  <el-select v-model="querys[1].value" style="width:100%" clearable placeholder="请选择所属片区">
                    <el-option v-for="item in jxcspqList" :key="item.value" :label="item.name" :value="item.value" />
                  </el-select>
                </el-form-item> -->
                <el-form-item label="商户名称">
                  <el-input v-model="querys[0].value" clearable placeholder="请输入商户名称" />
                </el-form-item>
                <el-form-item>
                  <el-button type="primary" icon="el-icon-search" @click="handleSearch">搜索</el-button>
                  <el-button icon="el-icon-refresh" @click="handleReset">重置</el-button>
                </el-form-item>
              </el-form>
            </div>
            <el-table ref="multipleSelection" v-loading="loading" border size="mini" :data="tableData"
              :style="{ width: '100%', height: '500px' }" height="52vh" :max-height="tableMaxHeight"
              :cell-style="{ 'text-align': 'center' }" :header-cell-style="{ 'text-align': 'center' }"
              @row-dblclick="handleDbClick" @selection-change="handleSelectionChange" @select="checkSelect"
              @select-all="checkSelect" v-if="activeName === '其它经营场所'" :row-key="getRowKey">
              <el-table-column type="selection" width="55" :reserve-selection="true" />
              <el-table-column type="index" width="55" label="序号" />
              <!-- <el-table-column prop="smallPlaceAreaName" min-width="150" label="所属片区" show-overflow-tooltip /> -->
              <el-table-column prop="unitName" label="商户名称" show-overflow-tooltip />
              <el-table-column prop="name" label="负责人" show-overflow-tooltip />
              <el-table-column prop="phone" label="联系电话" show-overflow-tooltip />
            </el-table>
          </el-tab-pane>
        </el-tabs>
      </template>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" @click="handleSave">保 存</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import { TableMixin } from '@/mixins/tableMixin'
import dictUtils from '@/components/dict/DictSelectUtils.js'
import nineLittlePlaceApi from '@/views/Manage/saftyDanger/api/nineLittlePlaceApi'

export default {
  name: 'CmgtSaftyDangerCheckplanFormDialogTroubleshooting', // 排查计划明细
  props: {
    title: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      showTroubleshooting: false, // 控制弹层显示与隐藏
      activeName: '九小场所管理',
      jxcspqList: null, // 片区字典数据
      querys: [
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'unit_name_',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'small_place_area_',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'type_',
          relation: 'AND',
          value: ''
        }
      ],
      sorter: [
        {
          direction: 'DESC',
          property: 'createTime'
        }
      ], // 排序数据
      selectData: []
    }
  },
  mixins: [TableMixin],
  created() {
    this.jxcspqList = dictUtils.getDictItemsFromCache('jxcspq') //九小场所片区
  },
  methods: {
    getRowKey(row) {
      return row.id
    },
    checkSelect(val) {
      this.selectData = JSON.parse(JSON.stringify(val))
    },
    add() {
      this.showTroubleshooting = true
    },
    // 切换tab选项
    handleClick(tab, event) {
      this.$refs.multipleSelection.clearSelection()
      this.selectData = []
      this.activeName = event.target.innerText
      this.querys = this.$options.data().querys
      console.log(this.querys);
      
      this.loadData()
    },
    // 获取list
    loadData(page) {
      if (page) {
        this.queryParam.pageBean.page = page
      }
      // 不分页
      this.queryParam.pageBean.pageSize = -1
      this.loading = true
      this.tableData = []
      this.queryParam.querys = []
      this.queryParam.sorter = this.sorter
      if (this.activeName === '九小场所管理') {
        if (this.querys[0].value) {
          this.queryParam.querys.push(this.querys[0])
        }
        if (this.querys[1].value) {
          this.queryParam.querys.push(this.querys[1])
        }
        this.querys[2].value = 1
        this.queryParam.querys.push(this.querys[2])
      } else if (this.activeName === '重点单位管理') {
        if (this.querys[0].value) {
          this.queryParam.querys.push(this.querys[0])
        }
        this.querys[2].value = 2
        this.queryParam.querys.push(this.querys[2])
      } else if (this.activeName === '其它经营场所') {
        if (this.querys[0].value) {
          this.queryParam.querys.push(this.querys[0])
        }
        this.querys[2].value = 3
        this.queryParam.querys.push(this.querys[2])
      }
      nineLittlePlaceApi.loadCmgtSaftyDangerUnit(this.queryParam).then(res => {
        this.total = res.data.total
        // this.tableData = res.data.rows
        
        this.tableData = [...this.selectData, ...res.data.rows]
        if (this.selectData.length) {
          this.tableData = Array.from(
            new Map(this.tableData.map(item => [item.id, item])).values()
          )
        }

        this.tableData.forEach(item => {
          this.jxcspqList.forEach(val => {
            if (item.smallPlaceArea == val.value) {
              item['smallPlaceAreaName'] = val.name
            }
          })
        })
        this.$set(this.tableData)
        this.loading = false
      })
    },
    // 重置
    clearQuerys() {
      this.querys[0].value = ''
      this.querys[1].value = ''
    },
    // 点击关闭按钮
    handleClose() {
      this.$refs.multipleSelection.clearSelection()
      this.showTroubleshooting = false
    },
    // 保存按钮
    handleSave() {
      let list = []
      this.multipleSelection.forEach(item => {
        this.tableData.forEach(it => {
          if (item === it.id) {
            list.push({ type: it.type, checkCompany: it.id })
          }
        })
      })
      this.$emit('addDetail', list)
      this.handleClose()
    }
  }
}
</script>

<style scoped lang="scss"></style>
